Bug 426738 - Review Request: pards - A library for PARallel programs with Dataflow Synchronization
Review Request: pards - A library for PARallel programs with Dataflow Synchro...
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Mamoru TASAKA
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-12-25 12:21 EST by MASA.H
Modified: 2008-01-13 21:52 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-01-13 21:52:38 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mtasaka: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description MASA.H 2007-12-25 12:21:58 EST
Spec URL: http://www.masahase.mydns.jp/SRPMS/pards.spec
SRPM URL: http://www.masahase.mydns.jp/SRPMS/pards-0.4-1.fc7.src.rpm
Description: This is a library for writing parallel programs (for UNIX OSes).
With this library, you can write parallel programs more easily than
using other libraries like pthread directly. As a practical example,
bzip2 is parallelized using this library.
Comment 1 Mamoru TASAKA 2007-12-25 12:49:13 EST
_Very_ quick check (before I can sponsor you). I am just
glancing at your spec file.

- Please fix SourceURL ref:
  http://cvs.fedoraproject.org/viewcvs/*checkout*/devel/jd/jd.spec

- BuildRequires: glibc-common, binutils are redundant

- Usually -devel package should have the dependency for main
  package
  (please see the line "MUST: 
   In the vast majority of cases, devel packages must... of
   http://fedoraproject.org/wiki/Packaging/ReviewGuidelines )

- "Group" of main package perhaps needs fixing ref:
   http://cvs.fedoraproject.org/viewcvs/*checkout*/devel/libtcd/libtcd.spec

- Move char code conversion section from %build to %prep
  (for rpmbuild -bc --short-circuit)

- Use "-p" option when using "cp" or "install" commands
  ("Timestamps" section of Guildlines wiki)

- Remove static archives unless needed

- It seems that -devel package does not contain any symlinks
  against installed libraries??
  (by the way "make install ...." does not work?)

- Stripping binaries by yourself is forbidden.

! Please insert one line between
---------------------------------------------------------
%doc ChangeLog README README.ja LICENSE
%files devel
----------------------------------------------------------
Comment 3 Mamoru TASAKA 2007-12-26 07:10:04 EST
Well,

- http://downloads.sourceforge.jp/pards/pards04.tar.gz
  returns 404 (not found).

- Rebuild fails on 64 bits arch (installation failure)
  http://koji.fedoraproject.org/koji/taskinfo?taskID=310050
Comment 4 Mamoru TASAKA 2007-12-26 07:36:39 EST
One more issue:

---------------------------------------------------------------------
[root@localhost ~]# rpmlint pards
pards.i386: W: undefined-non-weak-symbol /usr/lib/libpards.so.0.4
_ZTVN10__cxxabiv120__si_class_type_infoE
pards.i386: W: undefined-non-weak-symbol /usr/lib/libpards.so.0.4
_ZTVN10__cxxabiv117__class_type_infoE
pards.i386: W: undefined-non-weak-symbol /usr/lib/libpards.so.0.4
__gxx_personality_v0
pards.i386: W: undefined-non-weak-symbol /usr/lib/libpards.so.0.4 _ZdlPv
pards.i386: W: undefined-non-weak-symbol /usr/lib/libpards.so.0.4
__cxa_allocate_exception
pards.i386: W: undefined-non-weak-symbol /usr/lib/libpards.so.0.4 __cxa_throw
pards.i386: W: undefined-non-weak-symbol /usr/lib/libpards.so.0.4 _Znwj
------------------------------------------------------------------------

This means that libpards.so contains undefined non-weak symbol.
For packages providing -devel subpackage, this cannot be allowed
because these symbols cause linkage failure against this library.
Comment 5 MASA.H 2007-12-26 09:21:02 EST
Oh, shit.
>404
I miss repoid in soreceURL.

>fails on 64bit
It mistakenly defined libdir as ${prefix}/lib on all enviroment in Makefile. But
on 64bit it is ${prefix}/lib64.

>undefined non-weak symbol.
Oh, I missed "-lstdc++".
BTW, I have a question. My rpmlint doesn't tell. To tell needs some options or
new version?

fixed;
Spec URL: http://www.masahase.mydns.jp/SRPMS/pards.spec
SRPM URL: http://www.masahase.mydns.jp/SRPMS/pards-0.4-3.fc7.src.rpm


Comment 6 Mamoru TASAKA 2007-12-26 11:09:34 EST
(In reply to comment #1)
> - Remove static archives unless needed

Umm.. 
It seems that originally this package does not provide
any shared libraries but only a static archive. Then
you try to apply a patch to provide a shared library
with soname given by _you_.

This is actually problematic because we cannot tell if
ABI of the library really does not change when _upstream_ changes
from 0.4 to 0.5, for example.
c.f
https://bugzilla.redhat.com/show_bug.cgi?id=211626#c15
(the whole discussion is very long)

Well, now we allow to provide static archives when it is
unavoidable. Would you check the section "Packaging Static Libraries"
of http://fedoraproject.org/wiki/Packaging/Guidelines
(especially the subsection 
 "When a package only provides static libraries" ) and rewrite
your srpm?
Comment 7 Mamoru TASAKA 2007-12-26 11:11:14 EST
BTW:
> >undefined non-weak symbol.
> Oh, I missed "-lstdc++".
> BTW, I have a question. My rpmlint doesn't tell. To tell needs some options or
> new version?

You can try rpmlint against installed rpms, too, for example:
$ rpmlint pards
Comment 8 MASA.H 2007-12-26 13:03:39 EST
>original provides only static library
I see there's no assurance for ABI.
I'm trying to contact upstream developer, and send my patch. I continue to wait
his reply. As interim alternative I rewrite;
Spec URL: http://www.masahase.mydns.jp/SRPMS/pards.spec
SRPM URL: http://www.masahase.mydns.jp/SRPMS/pards-0.4-4.fc7.src.rpm
Comment 9 Mamoru TASAKA 2007-12-26 13:37:11 EST
Well, for now I will wait for upstream reply.
Comment 10 MASA.H 2007-12-31 07:46:20 EST
Upstream promised to no change ABI during same major version. And my patch will
merge next release.

So I will revert the pakcage from 4.fc7 to 3.fc7. Is it O.K?
Comment 11 Mamoru TASAKA 2007-12-31 07:58:07 EST
Well, would you "increase" release number anyway and resubmit
your newest srpm?
Comment 12 MASA.H 2007-12-31 09:54:19 EST
Of course, I'll increase. But I am away from my console, so resubmiting will late.
Comment 13 Mamoru TASAKA 2007-12-31 10:03:06 EST
Okay. BTW a happy new year!!
Comment 14 MASA.H 2007-12-31 10:25:24 EST
Happy new year!
Comment 16 Mamoru TASAKA 2008-01-07 10:13:46 EST
Well, this package is okay

----------------------------------------------------------
  This package (pards) is APPROVED by me
----------------------------------------------------------

So would you contact with accounts@fedoraproject.org
as written in 
http://fedoraproject.org/wiki/Infrastructure/AccountSystem/Contact
about GPG key problem if you still have the problem?
Comment 17 MASA.H 2008-01-07 13:19:56 EST
I've send a mail to accounts@fedoraproject.org, and recived mail from Mike
McGrath <mmcgrath@redhat.com>. But it has not solved yet.
Comment 18 Mamoru TASAKA 2008-01-12 13:01:20 EST
How about create a new GPG key for now?
Comment 19 MASA.H 2008-01-12 18:02:04 EST
Um... That is last way, I think.
But I'll try it.
Comment 20 MASA.H 2008-01-12 18:55:01 EST
I succeeded!!
Thank you very much.
Comment 21 Mamoru TASAKA 2008-01-12 21:44:34 EST
Okay, now I am sponsoring you. Please proceed following
"Join" wiki.
Comment 22 MASA.H 2008-01-13 08:09:15 EST
New Package CVS Request
=======================
Package Name: pards
Short Description: A library for PARallel programs with Dataflow Synchronization
Owners: masahase
Branches: F-7 F-8
InitialCC: 
Cvsextras Commits: yes
Comment 23 Kevin Fenzi 2008-01-13 13:07:02 EST
cvs done.
Comment 24 MASA.H 2008-01-13 21:52:38 EST
All builds succeeded.

Note You need to log in before you can comment on or make changes to this bug.